;********************************************************
;*	ٽުڰ vO			*
;********************************************************

;*****		*****
;	̧ٖ	PGEN1.ASM
;	gpϲ	ATMEL ATtiny2313
;	ۯ		OtXTAL 4MHz
;			AVRASM version 1.30 (EEPّ̧΍K{)
;	ҘA	Ԍs 	jh3dbo@jarl.com
;	2010-01-27	Jn
;	2010-04-13	ްޮ

;	PA : o
;	     210
;     	     ||+------	PA0 i	XTAL1
;     	     |+-------	PA1 i	XTAL2
;     	     +--------	PA2 i	RESET pull up
;	PB : o
;	76543210
;     	|||||||+------	PB0 o	DSW COM 10^2
;     	||||||+-------	PB1 i	۸ ڰ1 drdo
;     	|||||+--------	PB2 o	ϰ0 ٽo (ϰ1CLK͂)
;     	||||+---------	PB3 o	ϰ1 ٽo
;     	|||+----------	PB4 o	DSW COM 10^1
;     	||+-----------	PB5 o	<MOSI>  DSW COM 10^0
;     	|+------------	PB6 o	<MISO>  DSW uS,mS
;     	+-------------	PB7 o	<SCK>   DSW duty
;	PD : o
;	76543210
;     	 ||||||+------	PD0 i	DSW data 1
;     	 |||||+-------	PD1 o	(no use)
;     	 ||||+--------	PD2 i	DSW data 4
;     	 |||+---------	PD3 i	DSW data 8
;     	 ||+----------	PD4 i	DSW data 2
;     	 |+-----------	PD5 i	ϰ1 CLK
;     	 +------------	PD6 o	LED Lŵ (BAT LOœ_)


;*	Fuse bit L : 4MHzۯ̏ꍇ
;	#0 L	11001111 <CF>
;		||||++++------	CKSEL3`0 (XTAL 4MHz)
;		||++----------	START UP TIME SEL (BOD)
;		|+------------	CKOUT (Ȃ)
;		+-------------	CLK (1/1)
;*	Fuse bit H
;	#1 H	11011011 <DB>
;		|||||||+------	Oؾċ֎~ (Ȃ)
;		||||+++-------	׳ݱēd (2.7V)
;		|||+----------	ޯޏ펞 (Ȃ)
;		||+-----------	ر۸ݸ (SPI)
;		|+------------	EEPROM ۑ (Ȃ)
;		+-------------	Debug wire (Ȃ)
;*	Fuse bit X
;	#2 X	11111111 <FF>
;		       +------	 ۸ (Ȃ)

;*	ϰ̐ݒ
;	ϰ0 :  8bit ϰ ۯo
;		CLKݒ	CLK敪 o͎g
;		   0	 1uS	 2MHz
;		   1	 10uS	 2MHz
;		   2	 100uS	 200kHz
;		   3	 1mS	 20kHz
;		   4`9	 10mS	 2kHz
;	ϰ1 : 16bit ϰ PWMo
;		CLKݒ=0 (1uS)
;		   1`999,1000	~2
;		CLKݒ=1`4 (10uS`10mS)
;		   1`999,1000	~20


;****************************************
;*	`sQRPR@dpt	*
;****************************************

.include "tn2313.inc"


;****************************************
;*	}N				*
;****************************************
;	wordް̏ꍇ,LSB擪޲ĂƂȂ

.LISTMAC				;ϸۓWJؽĂ

;*****	X,Y,Zւ̲ިĒl *****
.MACRO	LDIX
	LDI	XL, low(@0)		;X reg <- 16bit valu
	LDI	XH,high(@0)
.ENDMACRO

.MACRO	LDIY
	LDI	YL, low(@0)		;Y reg <- 16bit valu
	LDI	YH,high(@0)
.ENDMACRO

.MACRO	LDIZ
	LDI	ZL, low(@0)		;Z reg <- 16bit valu
	LDI	ZH,high(@0)
.ENDMACRO

;*****	R16`31ڼ޽ւ̲ިĒl	*****
;	LDWI  RH,RL, 0x1234
.MACRO	LDWI
	LDI	@1,  low(@2)
	LDI	@0, high(@2)
.ENDMACRO

;*****	R16`31ڼ޽ւ̲ިĒlr	*****
;	CMPWI  H1,L1, 0x1234
.MACRO	CMPWI
	CPI	@0,high(@2)	;H޲
	BRNE	PC+2		;svȂ罷
	CPI	@1,low(@2)	;L޲Ăr
.ENDMACRO


;*****	ڼ޽Ԃ̑Z		*****
;	ADDW  H1,L1, H2,L2
.MACRO	ADDW
	ADD	@1,@3
	ADC	@0,@2
.ENDMACRO

;*****	ڼ޽Ԃ̈Z		*****
;	SUBW  H1,L1, H2,L2
.MACRO	SUBW
	SUB	@1,@3
	SBC	@0,@2
.ENDMACRO

;*****	ڼ޽Ԃ̔r		*****
;	CMPW  H1,L1, H2,L2
.MACRO	CMPW
	CP	@0,@2		;H޲
	BRNE	PC+2		;vȂ罷
	CP	@1,@3		;L޲Ăr
.ENDMACRO

;*****	ڼ޽ 	*****
;	XCHGW H1,L1, H2,L2
.MACRO	XCHGW
	PUSH	@0
	PUSH	@1
	MOVW	@1,@3			;0,1<-2,3
	POP	@3			;2,3<-0,1
	POP	@2
.ENDMACRO

;*****		*****
.MACRO	RETCS
	BRCC	PC+2
	RET
.ENDMACRO

.MACRO	RETCC
	BRCS	PC+2
	RET
.ENDMACRO

.MACRO	RETEQ
	BRNE	PC+2
	RET
.ENDMACRO

.MACRO	RETNE
	BREQ	PC+2
	RET
.ENDMACRO

;*****	ޯƼެ	*****
;	JBS reg,bit, adrs
.MACRO	JBS
	SBRC	@0,@1
	RJMP	@2
.ENDMACRO

;	JBC reg,bit, adrs
.MACRO	JBC
	SBRS	@0,@1
	RJMP	@2
.ENDMACRO

;*****	ޯ /ر	*****
;	SETB reg,bit
.MACRO	SETB
	SBR	@0,1 << @1
.ENDMACRO

;	CLRB reg,bit
.MACRO	CLRB
	CBR	@0,1 << @1
.ENDMACRO

;*****	׸#0 ,ر	*****
.MACRO	F0SET
	SBR	F_0,1 << @0
.ENDMACRO

.MACRO	F0CLR
	CBR	F_0,1 << @0
.ENDMACRO


;********************************
;*	I/O }N		*
;********************************

;*****	LED on/off	*****
.MACRO	LEDON
	CBI	PORTD,6
.ENDMACRO

.MACRO	LEDOFF
	SBI	PORTD,6
.ENDMACRO



;****************************************
;*	WX^̎w			*
;****************************************
;	ƼَR0`R31۸ر
;	R0LPM߂Ŏgp
;	R16`R31LDI,CPI߂g
;	R26`31X,Y,Z߲Ƃı
;	R26,27:XL,XH  R28,29:YL,YH  R30,31:ZL,ZH

;*****	ϰ		*****
.def	TM_LED		= R1		;LED _ŗpϰ
					;16mS down  max 4b
;*****	DSW ް	*****
.def	DSW_STB		= R2		;DSW ݔԍ
					;0`4
.def	DSW_MLT		= R3		;ۯI
					;0:1uS 1:10uS 2:100uS
					;3:1mS 4:10mS
.def	DSW_DUTY	= R4		;dutyI敪
					;0:1/2  1:1/4  2:1/8   3:1/16
					;4:1/32 5:1/64 6:1/128 7:1/256
					;8:1/512 9:1024
.def	DSW_CYCL	= R5		;ْl 0`999
.def	DSW_CYCH	= R6		; (0Ȃ1000ƂĈ)

;*****	荞ݎð ڼ޽ 	*****
.def	R_SREG1		= R15		;ϰ1荞 ðڼ޽ޔp

;*****	ėpڼ޽	*****
;	LDI,CPI߂g
;	16ޯ߱ڼ޽ƂȂ悤ɔzu
.def	AL		= R16		;ڼ޽ A
.def	AH		= R17
.def	BL		= R18		;ڼ޽ C
.def	BH		= R19
.def	CL		= R20		;ڼ޽ D
.def	CH		= R21
.def	DL		= R22		;ڼ޽ E
.def	DH		= R23

;*****	׸ް	*****
;*	׸ #0
.def	F_0		= R25		;8ޯĂ׸ް

.equ	F0_LED		= 0		;LED _ŏ׸

.equ	F0_DSWOK	= 1		;DSW ްm׸
					;5ǂݏoŵ
.equ	F0_DSWX		= 2		;DSW ްω׸
					;DSW_SCANDSW_DATAr

;*****	X,Y,Zڼ޽	*****
;	R26`31X,Y,Z߲Ƃı
.def	XL		= R26
.def	XH		= R27
.def	YL		= R28		;荞ݓŎgp
.def	YH		= R29		;荞ݓŎgp
.def	ZL		= R30
.def	ZH		= R31


;****************************************
;*	rq`lGA	@		*
;****************************************
;	128޲Ă̴ر 0060`00DF
;	̴͂ر̍Ō
	.dseg			;DATA segment
	.org 0x0060

;*****	DSW ް	*****
DSW_SCAN:	.byte	5		;5DSWް
					;BCDlŽı
					;10^2,10^1,10^0,MLT,DUTY̏
DSW_DATA:	.byte	5		;DSW ް
					;5mSCANƔr
					;ω


;****************************************
;*	xNgGA	@		*
;****************************************

;*****	Interrupt Vectors ****
	.cseg			;CODE segment
	.org 0

;*****	Vector		*****
	RJMP	INIT		;0  Reset
	RJMP	INIT		;1  External Interrupt0
	RJMP	INIT		;2  External Interrupt1
	RJMP	INIT		;3  Input capture interrupt 1
	RJMP	INIT		;4  Timer/Counter1 Compare Match A
	RJMP	INIT		;5  Overflow1 Interrupt
	RJMP	INIT		;6  Overflow0 Interrupt
	RJMP	INIT		;7  USART0 RX Complete Interrupt
	RJMP	INIT		;8  USART0 Data Register Empty Interrupt
	RJMP	INIT		;9  USART0 TX Complete Interrupt
	RJMP	INIT		;10 Analog Comparator Interrupt
	RJMP	INIT		;11 Pin Change Interrupt
	RJMP	INIT		;12 Timer/Counter1 Compare Match B
	RJMP	INIT		;13 Timer/Counter0 Compare Match A
	RJMP	INIT		;14 Timer/Counter0 Compare Match B
	RJMP	INIT		;15 USI start interrupt
	RJMP	INIT		;16 USI overflow interrupt
	RJMP	INIT		;17 EEPROM write complete
	RJMP	IWDTM		;18 Watchdog Timer Interrupt


;****************************************
;*	o[Wt@		*
;****************************************

;*****	۸іƓt	*****
	.db	"PGEN1     2010-04-13",0
		;01234567890123456789


;****************************************
;*	EIb`hbO^C}[荞	*
;****************************************

;*****	ޯ ϰ 荞	*****
;	悻16mSŊ荞
IWDTM:
	IN	R_SREG1,SREG		;ð ڼ޽ ޔ
	PUSH	AL
	PUSH	AH
	PUSH	BL
	PUSH	ZL
	PUSH	ZH

;*	DSW ݏ 5𽷬
	RCALL	DSWRD			;ްذ(0`9)
	MOV	BL,AL
	LDI	AL,0b11110001		;Port D ۰ off
	OUT	PORTB,AL		;S

;	ްı
	MOV	AL,DSW_STB		;۰ޔԍ 0`4
	LDIZ	DSW_SCAN		;ް 擪ڽ
	ADD	ZL,AL			;ڽɉZ(8ޯČvZŉ)
	ST	Z,BL			;ްı

;	۰
	INC	DSW_STB			;۰
	MOV	AL,DSW_STB
	CPI	AL,5			;0`4
	BRLO	IWDTM11			;܂
;	5m
	CLR	DSW_STB			;5ɂȂ0
	F0SET	F0_DSWOK		;DSW ްm׸޵
IWDTM11:
	RCALL	DSWSTB			;۰ޏo

;*	16ms ϰ
;	LED ϰ
	TST	TM_LED			;16ms޳ݶϰ
	BREQ	PC+2			;łɾ
	DEC	TM_LED			;0łȂ-1

;*	荞-
IWDTMRET:
	POP	ZH
	POP	ZL
	POP	BL
	POP	AH
	POP	AL
	OUT	SREG,R_SREG1		;ð ڼ޽ A
	RETI



;****************************************
;*	CjV	@		*
;****************************************

;*****	CjV	*****
;	d,ؾĂ޸قł
;	dݎŐݒӰ
INIT:
	LDI	AL,low(RAMEND)		;RAM ŏIڽ L
	OUT	SPL,AL			;߲ݒ(8bit)

;*	ڼ޽ ر ر
	CLR	ZH			;ZH=0
	LDI	ZL,30			;R29ڽر
INIT11:
	ST	-Z,ZH			;Z--, (Z) <- 00
	TST	ZL			;R29`R0
	BRNE	INIT11			;loop

;	SRAM ر ر
	CLR	ZH
	LDI	ZL,0x60			;RAM Jnڽ
	CLR	AL
INIT12:
	ST	Z+,AL			;(Z) <- 00, Z++
	CPI	ZL, low(RAMEND+1)	;RAM ŏIڽ L
	BRNE	INIT12
	CPI	ZH,high(RAMEND+1)	;RAM ŏIڽ H
	BRNE	INIT12

;*	I/OƼ
;	Port A
	LDI	AL,0b00000100		;Port A oް
	;	          +++---- PA0`2 ٱߗL
	OUT	PORTA,AL
	LDI	AL,0b00000000
	;	          ||+---- PA0 i	XTAL1
	;	          |+----- PA1 i	XTAL2
	;	          +------ PA2 i	RESET pull up
	OUT	DDRA,AL			;I/O ݒ

;	Port B	
	LDI	AL,0b11110001		;Port B oް
;		     ++++---+------	DSW COM
	OUT	PORTB,AL
	LDI	AL,0b11111101
;     		     |||||||+------	PB0 o	DSW COM 10^2
;     		     ||||||+-------	PB1 i	۸ ڰ1
;     		     |||||+--------	PB2 o	ϰ0 ٽo (ϰ1CLK͂)
;     		     ||||+---------	PB3 o	ϰ1 ٽo
;     		     |||+----------	PB4 o	DSW COM 10^1
;     		     ||+-----------	PB5 o	<MOSI>  DSW COM 10^0
;     		     |+------------	PB6 o	<MISO>  DSW uS,mS
;     		     +-------------	PB7 o	<SCK>   DSW duty
	OUT	DDRB,AL			;I/O ݒ

;	Port D
	LDI	AL,0b11111111		;Port D oް
	OUT	PORTD,AL		;ٱߗL
	LDI	AL,0b01000010
;     		      ||||||+------	PD0 i	DSW data 1
;     		      |||||+-------	PD1 o	(no use)
;     		      ||||+--------	PD2 i	DSW data 4
;     		      |||+---------	PD3 i	DSW data 8
;     		      ||+----------	PD4 i	DSW data 2
;     		      |+-----------	PD5 i	ϰ1 CLK
;     		      +------------	PD6 o	LED Lŵ
	OUT	DDRD,AL			;I/O ݒ

;*	ڰ
	LDI	AL,0b01000000
;		     ||||||++--- ACIS
;		     |||||+----- ACIC
;		     ||||+------ ACIE
;		     |||+------- ACI
;		     ||+-------- ACO
;		     |+--------- ACBG	1:޷ެߐڑ
;		     +---------- ACD	0:ڰ Ȱ
	OUT	ACSR,AL		;ڰ

;*	ޯϰ荞
;	OSC/2048 = 16mS
	WDR				;ޯ ؾ
	IN	AL,WDTCSR		;ޯ ڼ޽
	SETB	AL,WDCE			;change enable
	OUT	WDTCSR,AL
	LDI	AL,0b01000000
;		     ||+||+++--- WDP	ؽ 1/2048
;		     || |+------ WDE
;		     || +------- WDCE	change enable
;		     |+--------- WDIE	int enable
;		     +---------- WDIF
	OUT	WDTCSR,AL

;*	荞݊Jn
	SEI				;荞ݲȰ

;	LED on
	LEDON				;LED_

;	ϰ҂
	LDI	AL,10			;160mS
	MOV	TM_LED,AL		;16mSϰ
	TST	TM_LED
	BRNE	PC-1			;ѱߑ҂

;	DSW ްm҂
	F0CLR	F0_DSWOK		;DSWްm׸ ر
	SBRS	F_0,F0_DSWOK		;DSWްm҂
	RJMP	PC-1			;
	F0SET	F0_DSWX			;DSWްω׸ނ
					;ŏ̐ݒo͂邽
;*	C
;	
;	
;	RJMP	MAINLP			;Ҳٰ߂


;****************************************
;*	C[vs@		*
;****************************************

;*****	Ҳٰ		*****
MAINLP:
	SBRS	F_0,F0_DSWOK		;DSW5݊?
	RJMP	MLP1			;܂

;	DSW ω
	F0CLR	F0_DSWOK		;DSW ްm׸ ر
	RCALL	DSWXCHK			;DSW ްω
					;ݒɕωF0_DSWX
;	ϰݒ
MLP1:
	SBRS	F_0,F0_DSWX		;DSWω?
	RJMP	MLP2			;Ȃ

	RCALL	DSWDCONV		;CYC,MLT,DUTYްϊ
	RCALL	TIMSET			;ϰ0,1ݒ o͊Jn
	F0CLR	F0_DSWX			;DSWω׸ނر

;	Bat Lo 
MLP2:
	RCALL	BATLO			;drdLED_
	RJMP	MAINLP			;loop




;****************************************
;*	crvǂݏo			*
;****************************************

;*****	DSW ߰ذ	*****
;	۰ނ͏oĂƂްǂ
;	out AL 0`9
;	use AH
DSWRD:
	IN	AH,PIND			;port D 3,2,4,0
	COM	AH			;ް]
	MOV	AL,AH
	ANDI	AL,0b00001101		;3,2,-,0
	SBRC	AH,4			;PD4ް1 LȂ罷
	ORI	AL,0b00000010		;HȂ1
	CPI	AL,10			;0`9 ?
	RETCS				;͈͓
	LDI	AL,9			;10ȏ9
	RET

;*****	DSW ۰ޏo		*****
;	PortB 7654,05bit
DSWSTB:
	MOV	AL,DSW_STB		;DSW ݔԍ
	LDIZ	2*DSWSTBD		;۰ް
	RCALL	TBLRDB			;AL
	OUT	PORTB,AL		;۰ޏo
	RET

;*	۰ ް
;	Lŵ
DSWSTBD:
	.db	0b11110000,0b11100001		;0,1
	.db	0b11010001,0b10110001		;2,3
	.db	0b01110001,0b11110001		;4,5
	;	  ||||   |
	;	  ||||   +-----	0
	;	  |||+---------	1
	;	  ||+----------	2
	;	  |+-----------	3
	;	  +------------	4


;*****	DSW ްω	*****
;	SǂݏoF0_DSWOK݂
;	ݸނs
DSWXCHK:
	LDIX	DSW_SCAN		;ް(荞݂ž)
	LDIY	DSW_DATA		;mް
;	5
	LDI	BL,5			;5
DSWXCHK1:
	LD	AL,X			;SCAN
	LD	AH,Y			;DATA
	CP	AL,AH			;ω?
	BREQ	DSWXCHK2		;Ȃ罷

;	ωκ߰
	ST	Y,AL			;Vްı
	F0SET	F0_DSWX			;DSWްω׸ނ

;	ް
DSWXCHK2:
	INC	XL			;RAM ڽ +1
	INC	YL
	DEC	BL			;5?
	BRNE	DSWXCHK1		;loop
	RET

;*****	DSW ްϊ		*****
;	ْl,MLT,DUTYvZ
DSWDCONV:
	LDIX	DSW_DATA		;DSW ް (5)
;	ْl 3 (1`999,01000)
	CLR	AH
	CLR	AL
	LDI	CL,3			;3
DSWDCONV1:
	RCALL	MLT10			;AH,AL~10
	LD	BL,X+			;data
	CLR	BH
	ADD	AL,BL			;0`9Z
	ADC	AH,BH
	DEC	CL
	BRNE	DSWDCONV1		;loop
	CMPWI	AH,AL, 0		;
	BRNE	DSWDCONV2
	LDWI	AH,AL, 1000		;0Ȃ1000
DSWDCONV2:
	MOV	DSW_CYCL,AL		;ْl
	MOV	DSW_CYCH,AH
;	MLT
	LD	AL,X+			;data+3
	CPI	AL,5			;0`4L
	BRLO	DSWDCONV3
	LDI	AL,4			;5ȏ4
DSWDCONV3:
	MOV	DSW_MLT,AL		;MLTݒ 0`4
;	DUTY
	LD	DSW_DUTY,X+		;data+4
	RET


;****************************************
;	^C}[ݒ			*
;****************************************
;	Ҳݸۯ 4MHz
;	ϰ 0 : PB2 ϰ1ւCLK𔭐
;		CTCӰނȂ̂ź߱g1/2ɂȂ
;		1/1	1-1=2MHz,2-1=1MHz,4-1=500kHz
;			10-1=200kHz,20-1=100kHz
;			100-1=20kHz,200-1=10kHz
;		1/8	125-1=2kHz,250-1=1kHz
;		1/64	125-1=250Hz
;	ϰ 1 : PB3 oٽ

;*****	ϰ0,1ݒ		*****
;	ϰ0:ۯ
;	ϰ1:ٶ
TIMSET:
	MOV	AL,DSW_MLT		;MLTݒl 0`4
	ADD	AL,AL			;*2
	LDIZ	2*TIM0SETD		;ϰ0 ݒް
	RCALL	TBLRDB			;AL
	OUT	OCR0A,AL		;ϰ0 l
	LDI	AL,0			; ر
	OUT	TCNT0,AL

;	ϰ0 ڼ޽
	LDI	AL,0b01000010
	;	     ||||  ++---- WGM  CTC
	;	     ||++-------- OC0B PD5 gp
	;	     ++---------- OC0A PB2 CLKo
	OUT	TCCR0A,AL
	LPM	AL,Z+			;ðذ
	OUT	TCCR0B,AL		;ۯ ؽאݒ

;	ϰ1 ٶĐݒ
	MOV	AL,DSW_CYCL		;ِݒl 1`1000
	MOV	AH,DSW_CYCH
	MOV	CL,DSW_MLT		;MLTݒl 0`4
	CPI	CL,0			;0ȊOͻق10{
	BREQ	TIMSET1			;0͂̂܂
	RCALL	MLT10			;AH,AL~10
TIMSET1:
	MOV	XL,AL			;dutyݒ̂߂Xɺ߰
	MOV	XH,AH
;	ِݒ *2-1
	ADD	XL,XL			;*2
	ADC	XH,XH
	SBIW	XL,1			;-1
	OUT	ICR1H,XH		;ϰ 1
	OUT	ICR1L,XL		;PWM top

;	dutyl  ق1/2ɂȂĂ
;	ݒ肾1/2
	MOV	XL,AL			;Xɺ߰
	MOV	XH,AH
	MOV	CL,DSW_DUTY		;dutyݒl 0:1/2`
TIMSET2:
	TST	CL			;0 ?
	BREQ	TIMSET3			;0Ȃ炨
	LSR	XH			;1/2
	ROR	XL
	DEC	CL
	RJMP	TIMSET2			;܂
;	0Ȃ1
TIMSET3:
	MOV	CH,XL			;0?
	OR	CH,XH
	BRNE	TIMSET4
	LDWI	XH,XL, 1		;0Ȃ1
;	-1Đݒ
TIMSET4:
	SBIW	XL,1			;-1
	OUT	OCR1AH,XH		;ICR1OCR1ɂPWM
	OUT	OCR1AL,XL
	LDIX	0			; ر
	OUT	TCNT1H,XH
	OUT	TCNT1L,XL
;	ϰ1 
	LDI	AL,0b10000010
	;	     ||||  ++---- WGM  mode14
	;	     ||++-------- OC1B gp
	;	     ++---------- OC1A PB3 o
	OUT	TCCR1A,AL
	LDI	AL,0b00011110
	;		||+++---- CS   T1 CLḰ
	;		++------- WGM  mode14
	OUT	TCCR1B,AL
	RET

;*	ϰ 0 ݒް	OCR0A,TCCR0B  (*10:CYCl10{Đݒ)
TIM0SETD:
	.db	1-1,	0b00000001	;0 1/1	1uS	2MHz
	.db	1-1,	0b00000001	;1 1/1	10uS	2MHz	*10
	.db	10-1,	0b00000001	;2 1/1	100uS	200kHz	*10
	.db	100-1,	0b00000001	;3 1/1	1mS	20kHz	*10
	.db	125-1,	0b00000010	;4 1/8	10mS	2kHz	*10


;****************************************
;*	drdቺo		*
;****************************************

;*****	Bat Low, LED _,_ŕ\	*****
;	0.25bقźڰ
;	ڰHȂBat Low\œ_
BATLO:
	TST	TM_LED			;10mSϰ
	RETNE				;܂

;	ϰ
	LDI	AL,16			;ϰ250mS
	MOV	TM_LED,AL		;16mS x 16

;	ڰ 
	SBIS	ACSR,ACO		;ڰ 
	RJMP	BATLO1			;LȂ罷

;	ACO=H dႢ,LED_ŏ
	SBRS	F_0,F0_LED		;łɓ_?
	RJMP	BATLO1			;܂

;	LED
	LEDOFF				;LED
	F0CLR	F0_LED			;LED_ŏ׸ނر
	RET

;	ACO=L Batd,LED_
BATLO1:
	LEDON				;LED_
	F0SET	F0_LED			;LED_ŏ׸ނ
	RET



;****************************************
;*	vZTu[`@		*
;****************************************

;*****	10{ Z	*****
;	AH,AL10{
MLT10:
	PUSH	BL
	PUSH	BH
	ADD	AL,AL			;*2
	ADC	AH,AH
	MOV	BL,AL			;BH,BLɺ߰
	MOV	BH,AH
	ADD	AL,AL			;*4
	ADC	AH,AH
	ADD	AL,AL			;*8
	ADC	AH,AH
	ADD	AL,BL			;+2
	ADC	AH,BH
	POP	BH
	POP	BL
	RET


;*****	޲ ްð ǂݏo	****
;	ZH,ZL + AL vZ
;	out ROM޲ް AL
;	use AH
;		LDIZ	(2*TABLE)
;		LDS	AL,DATA
;		RCALL	TBLRDB
;	LPMű\
TBLRDB:
	CLR	AH
	ADD	ZL,AL			;ڽðقɉZ
	ADC	ZH,AH
	LPM	AL,Z+			;ðذ
	RET

;*****	ܰްð ǂݏo	****
;	in  ZH,ZL:ðٱڽ
;	    AL:  ް敪 0`n(max 127)
;	out ZH,ZL:ܰް
;	use AH
;		LDIZ	2*TBL		;ڽðق̐擪
;		MOV	AL,TBL_NO	;敪
;		RCALL	TBLRDW
TBLRDW:
	ADD	AL,AL			;*2
	CLR	AH			;AHg
	ADD	ZL,AL			;ڽðقɉZ
	ADC	ZH,AH
	LPM	AL,Z+			;ް L޲
	LPM	ZH,Z			;ް H޲
	MOV	ZL,AL			;ZH,ZLް
	RET

;*****	IJMP̂߂̱ڽ۰ޏ	****
;	in  ZH,ZL:ðٱڽ
;	    AL:  s敪 0`n
;	out ZH,ZL:ެߐ
;		LDIZ	2*JMP		;sڽðق̐擪
;		MOV	AL,JMP_EXC	;s敪
;		RCALL	TBLJMP
;	use R0
TBLJMP:
	ADD	AL,AL			;*2
	CLR	R0
	ADD	ZL,AL			;ڽðقɉZ
	ADC	ZH,R0
	LPM	AL,Z+			;ެߐ L޲
	LPM				;ެߐ H޲
	MOV	ZH,R0
	MOV	ZL,AL
	IJMP				;ZH,ZL


;/////	end of "PGEN1.ASM"	/////
